import { jsx as _jsx } from "react/jsx-runtime";
import ReactECharts from "echarts-for-react";
import React, { useEffect } from "react";
const VerticalBarChart = (props) => {
    const [status, setStatus] = React.useState('loading');
    const [chartData, setChartData] = React.useState([]);
    const getChartDataAsync = async (arg) => {
        try {
            const result = await props.configuration.fnGetChartDataAsync(arg);
            setStatus('loaded');
            setChartData(result);
        }
        catch (error) {
            setStatus('error');
            setChartData([]);
        }
    };
    useEffect(() => {
        getChartDataAsync({ id: props.configuration.setup.id });
    }, []);
    if (status === 'loading') {
        if (props.configuration.loadingComponent)
            return props.configuration.loadingComponent;
        return (_jsx("div", { className: "s-dashboard-item s-dashboard-item-loading", children: _jsx("h1", { children: "Loading..." }) }));
    }
    if (status === 'error') {
        if (props.configuration.errorComponent)
            return props.configuration.errorComponent;
        return (_jsx("div", { className: "s-dashboard-item s-dashboard-item-error", children: _jsx("h1", { children: "Error" }) }));
    }
    const serials = new Set();
    const xValues = new Set();
    chartData.forEach((item) => {
        serials.add(item[props.configuration.setup.seriesField]);
        xValues.add(item[props.configuration.setup.xAxisField]);
    });
    const getOption = () => {
        return {
            grid: {
                left: "3%",
                top: 30,
                right: 10,
                bottom: 10,
                containLabel: true,
            },
            legend: {},
            tooltip: {},
            dataset: {
                source: [
                    [props.configuration.setup.seriesField, ...Array.from(serials)],
                    ...Array.from(xValues).map(xValue => [xValue, ...Array.from(serials).map(serial => chartData.find(item => item[props.configuration.setup.seriesField] === serial && item[props.configuration.setup.xAxisField] === xValue)?.[props.configuration.setup.yAxisField] || 0)])
                ],
            },
            xAxis: { type: "category" },
            yAxis: {},
            series: Array.from(serials).map(() => { return { type: "bar" }; }),
        };
    };
    return _jsx(ReactECharts, { option: getOption() });
};
export default VerticalBarChart;
