import { jsx as _jsx } from "react/jsx-runtime";
import React, { useEffect } from 'react';
import VerticalBarChart from './charts/VerticalBarChart';
const SDashboard = (props) => {
    const [status, setStatus] = React.useState('loading');
    const [dashboardItems, setDashboardItems] = React.useState([]);
    const getItemsAsync = async () => {
        try {
            const result = await props.configuration.fnGetItemsAsync({ dashboardCode: props.dashboardCode });
            setStatus('loaded');
            setDashboardItems(result);
        }
        catch (error) {
            setStatus('error');
            setDashboardItems([]);
        }
    };
    useEffect(() => {
        getItemsAsync();
    }, []);
    if (status === 'loading') {
        if (props.configuration.loadingComponent)
            return props.configuration.loadingComponent;
        return (_jsx("div", { className: "s-dashboard s-dashboard-loading", children: _jsx("h1", { children: "Loading..." }) }));
    }
    if (status === 'error') {
        if (props.configuration.errorComponent)
            return props.configuration.errorComponent;
        return (_jsx("div", { className: "s-dashboard s-dashboard-error", children: _jsx("h1", { children: "Error" }) }));
    }
    return (_jsx("div", { className: "s-dashboard s-dashboard-loaded", children: dashboardItems.map((item, index) => {
            return (_jsx(VerticalBarChart, { configuration: {
                    fnGetChartDataAsync: props.configuration.fnGetChartDataAsync,
                    setup: item.setup
                } }, index));
        }) }));
};
export default SDashboard;
